=== debian/changelog ===
grafx2 (2.5.1960+ds1-0.1~mx17+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 13 Jun 2018 13:08:55 -0700

grafx2 (2.5+ds1-0.1~mx17+1) mx; urgency=medium

  * New upstream version; build for MX 17.
  * Repack to include recoil source tarball instead of downloading it during
    the build.
  * Revert to debhelper 10.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 07 May 2018 16:41:08 -0700
